<?php

namespace IMATHUZH\Qfq\Core\Renderer\FormElement\Bootstrap3;

use IMATHUZH\Qfq\Core\Form\FormElement\AbstractFormElement;

class Bootstrap3PillRenderer extends \IMATHUZH\Qfq\Core\Renderer\FormElement\Base\PillRenderer
{
    /**
     * Renders the pill container and all its nested formelements (children).
     * Note that the Navigation (Button to show this pill) is rendered seperately in the method renderFormHead() of BaseRenderer or its derived classes.
     * @param AbstractFormElement $fe
     * @param string $renderMode
     * @return string
     */
    public function renderFormElement(AbstractFormElement $fe, string $renderMode = RENDER_MODE_HTML): string
    {
        $childrenHtml = $this->renderChildren($fe, $renderMode);
        $pillHtmlId = $fe->htmlAttributes[HTML_ATTR_ID];

        $class = "";
        if ($fe->attributes[FE_MODE] == FE_MODE_HIDDEN) {
            $class = ' hidden';
        } else {
            $class = $fe->isFirstPill ? ' active' : '';
        }

        return <<<EOL
                <div id="$pillHtmlId" class="tab-pane$class" role="tabpanel">
                    <div class="col-md-12 qfq-form-body qfq-color-grey-2">
                        $childrenHtml
                    </div>
                </div>
                EOL;
    }
}